Package org.htmlunit

# Class ScriptException

java.lang.Object
java.lang.Throwable
java.lang.Exception
java.lang.RuntimeException
org.htmlunit.ScriptException

All Implemented Interfaces:
  `Serializable`

public class ScriptException extends RuntimeException
An exception that will be thrown if an error occurs during the processing of a script.

See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ScriptException(HtmlPage page, Throwable throwable)`
  Creates an instance.
  `ScriptException(HtmlPage page, Throwable throwable, String scriptSourceCode)`
  Creates an instance.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getFailingColumnNumber()`
  Returns the column number of the source that was executing at the time of the exception.
  `String`
  `getFailingLine()`
  Returns the line of source that was being executed when this exception was thrown.
  `int`
  `getFailingLineNumber()`
  Returns the line number of the source that was executing at the time of the exception.
  `HtmlPage`
  `getPage()`
  Gets the HTML page in which the script error occurred.
  Caution: this page may be only partially parsed if the exception occurred in a script executed at parsing time.
  `String`
  `getScriptSourceCode()`
  Returns the source code line that failed.
  `void`
  `printScriptStackTrace(PrintWriter writer)`
  Prints the script stack trace.
  `void`
  `printStackTrace()`
  Prints the stack trace to System.out.
  `void`
  `printStackTrace(PrintStream stream)`
  Prints the stack trace.
  `void`
  `printStackTrace(PrintWriter writer)`
  Prints the stack trace.

  ### Methods inherited from class java.lang.Throwable

  `addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, setStackTrace, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ScriptException

    public ScriptException(HtmlPage page, Throwable throwable, String scriptSourceCode)
    Creates an instance.
    Parameters:
      `page` - the page in which the script causing this exception was executed
      `throwable` - the exception that was thrown from the script engine
      `scriptSourceCode` - the code that was being executed when this exception was thrown. This may be null if the exception was not caused by execution of JavaScript.

  - ### ScriptException

    public ScriptException(HtmlPage page, Throwable throwable)
    Creates an instance.
    Parameters:
      `page` - the page in which the script causing this exception was executed
      `throwable` - the exception that was thrown from the script engine

- ## Method Details

  - ### printStackTrace

    public void printStackTrace()
    Prints the stack trace to System.out. If this exception contains another exception then the stack traces for both will be printed.
    Overrides:
      `printStackTrace` in class `Throwable`

  - ### printStackTrace

    public void printStackTrace(PrintWriter writer)
    Prints the stack trace. If this exception contains another exception then the stack traces for both will be printed.
    Overrides:
      `printStackTrace` in class `Throwable`
    Parameters:
      `writer` - Where the stack trace will be written

  - ### printStackTrace

    public void printStackTrace(PrintStream stream)
    Prints the stack trace. If this exception contains another exception then the stack traces for both will be printed.
    Overrides:
      `printStackTrace` in class `Throwable`
    Parameters:
      `stream` - Where the stack trace will be written

  - ### getScriptSourceCode

    public String getScriptSourceCode()
    Returns the source code line that failed.
    Returns:
      the source code line that failed

  - ### getFailingLine

    public String getFailingLine()
    Returns the line of source that was being executed when this exception was thrown.
    Returns:
      the line of source or an empty string if the exception was not thrown due to the execution of a script.

  - ### getFailingLineNumber

    public int getFailingLineNumber()
    Returns the line number of the source that was executing at the time of the exception.
    Returns:
      the line number or -1 if the exception was not thrown due to the execution of a script.

  - ### getFailingColumnNumber

    public int getFailingColumnNumber()
    Returns the column number of the source that was executing at the time of the exception.
    Returns:
      the column number or -1 if the exception was not thrown due to the execution of a script.

  - ### getPage

    public HtmlPage getPage()
    Gets the HTML page in which the script error occurred.
    Caution: this page may be only partially parsed if the exception occurred in a script executed at parsing time.
    Returns:
      the page

  - ### printScriptStackTrace

    public void printScriptStackTrace(PrintWriter writer)
    Prints the script stack trace. This represents only the script calls.
    Parameters:
      `writer` - where the stack trace will be written